(*
  PROJECT: FV3DLL.pas
  DESCRIPTION: Delphi Header for FV3DLL.dll
  DATE: 2005/01/30
  VERSION: 1.1
  AUTHORS: H U M A X - Community
  WEBPAGE: http://humax.roliaforum.com
*)

unit FV3DLL;

interface

uses
  Windows;

type
  TOAKAbout = procedure; cdecl;
  TRawToHnf = procedure(InputFile, OutputFile : PChar; MenuType, FlashType : Byte); cdecl;
  THnfToHDF = procedure(InputFile,OutputFile : PChar; MenuType, FlashTyp, AntTyp : Byte; SystemID : Longint); cdecl;
  TV3Hnf = procedure(InputFile, OutputFile : PChar); cdecl;
  TGetIRDModel = function(Port, BaudRate : Byte) : Byte; cdecl;
  TTransfer = procedure(Port,BauRate : Byte; FileName : PChar); cdecl;

var
  DLLHandle : THandle;
  OAKAbout : TOAKAbout;
  RawToHnf : TRawToHnf;
  HnfToHDF : THnfToHDF;
  HnfToV3Hnf : TV3Hnf;
  V3HnfToHnf : TV3Hnf;
  GetIRDModel : TGetIRDModel;
  UploadData : TTransfer;
  UploadSystemID : TTransfer;
  DownloadData : TTransfer;

function FV3DLLInit : Boolean;
procedure FV3DLLDone;

implementation

function FV3DLLInit : Boolean;
begin
  Result := False;

  DLLHandle := LoadLibrary('FV3DLL.dll');
  
  if (DLLHandle <> 0) then
  begin
    @OAKAbout := GetProcAddress(DLLHandle,'OAKAbout');
    @RawToHnf := GetProcAddress(DLLHandle,'RawToHnf');
    @HnfToHDF := GetProcAddress(DLLHandle,'HnfToHDF');
    @HnfToV3Hnf := GetProcAddress(DLLHandle,'HnfToV3Hnf');
    @V3HnfToHnf := GetProcAddress(DLLHandle,'V3HnfToHnf');
    @GetIRDModel := GetProcAddress(DLLHandle,'GetIRDModel');
    @UploadData := GetProcAddress(DLLHandle,'UploadData');
    @UploadSystemID := GetProcAddress(DLLHandle,'UploadSystemID');
    @DownloadData := GetProcAddress(DLLHandle,'DownloadData');
    Result := True;
  end;
end;

procedure FV3DLLDone;
begin
  FreeLibrary(DLLHandle);
end;

end.
