unit UnitForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, CRC32, MD5, FV3DLL;

type
  TForm1 = class(TForm)
    OpenButton: TButton;
    MD5Edit: TEdit;
    OpenDialog: TOpenDialog;
    CRC32Edit: TEdit;
    StatusBar: TStatusBar;
    UploadButton: TButton;
    PortComboBox: TComboBox;
    SpeedComboBox: TComboBox;
    procedure OpenButtonClick(Sender: TObject);
    procedure UploadButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.OpenButtonClick(Sender: TObject);
var
  f : file;
  p : pointer;
  n : integer;
  crc32 : longword;
  md5digest : TMD5Digest;
begin
  if not OpenDialog.Execute then exit;

  StatusBar.SimpleText := OpenDialog.FileName;

  AssignFile(f,OpenDialog.FileName);
  Reset(f,1);
  n := fileSize(f);

  GetMem(p,n);

    BlockRead(f,p^,n);

    crc32 := 0; CalcCRC32(p,n,crc32);
    md5digest := MD5Buf(p^,n);

  FreeMem(p,n);

  CloseFile(f);

  CRC32Edit.Text := lowercase(IntToHex(crc32,8));
  MD5Edit.Text := MD5DigestToString(md5digest);
end;

procedure TForm1.UploadButtonClick(Sender: TObject);
begin
  if StatusBar.SimpleText = '' then exit;

  if not FV3DLLInit then exit;

    DownloadData( Byte(PortComboBox.ItemIndex), Byte(SpeedComboBox.ItemIndex), PChar(OpenDialog.FileName) );

  FV3DLLDone;
end;

end.
